#ifndef INC_GTCBLIST_H
#define INC_GTCBLIST_H

#include "gttypes.h"
#include "gtslink.h"

/************************************************************************\
*
* GtCBList class header.
*
* This class is used as a callback list. It allows adding and removing
* of functions from the list and calling the functions on the list.
*
* $Ident: This file is part of the 'Gt-library' 1.0.0 $
* $Copyright: (C) 1997 by Gran Gustafsson $
*
\************************************************************************/

class GtBase;

/* Type of caller provided data */
typedef void *GtCDPtr;

/* Type of user provided data */
typedef void *GtUDPtr;

/* Type of the callback function */
typedef int (*GtCallB)(GtBase *obj,GtCDPtr cd,GtUDPtr ud);

/* Return values from callbacks */
#define GTCB_CONT		0
#define GTCB_BREAK	1


class GtCBList
{
public:
	GtCBList(void);
	~GtCBList(void);
	int AddCB(GtCallB cb,GtUDPtr ud);
	void RemCB(GtCallB cb);
	void RemCB(int id);
	int CallCB(GtBase *obj,GtCDPtr cd);
protected:
	GtSLink hd;
};

#endif /* INC_GTCBLIST_H */
